package com.zoo.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zoo.common.R;
import com.zoo.dto.AdminDto;
import com.zoo.entity.*;
import com.zoo.service.IAccountService;
import com.zoo.service.IAdminService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author DJ
 * @since 2024-05-17
 */
@RestController
@RequestMapping("/zoo/admin")
public class AdminController {
    @Autowired
    IAdminService iAdminService;
    @Autowired
    IAccountService iAccountService;
    @GetMapping("/info")
    public R info(Integer id){
        QueryWrapper<Admin> queryWrapper = new QueryWrapper<>();
        QueryWrapper<Account> queryWrapper1 = new QueryWrapper<>();
        if (id!=null){
            queryWrapper.eq("roleid",id);
            Admin admin = iAdminService.getOne(queryWrapper);
            queryWrapper1.eq("roleid",id);
            queryWrapper1.eq("permissions",0);
            Account one = iAccountService.getOne(queryWrapper1);
            AdminDto adminDto = new AdminDto();
            BeanUtils.copyProperties(admin,adminDto);
            adminDto.setPassword(one.getPassword());
            adminDto.setUsername(one.getUsername());
            adminDto.setPermissions(0);
            return R.success(adminDto);
        }
        List<Admin> list = iAdminService.list();
        List<AdminDto> adminDtoList = list.stream().map((item)->{
            AdminDto adminDto = new AdminDto();
            BeanUtils.copyProperties(item,adminDto);
            QueryWrapper<Account> queryWrapper2 = new QueryWrapper<>();
            queryWrapper2.eq("roleid",item.getRoleid());
            queryWrapper2.eq("permissions",0);
            Account one = iAccountService.getOne(queryWrapper2);
            adminDto.setPassword(one.getPassword());
            adminDto.setUsername(one.getUsername());
            adminDto.setPermissions(0);
            return adminDto;
        }).collect(Collectors.toList());

        return R.success(adminDtoList);
    }
    @PostMapping("/add")
    public R add(Admin admin){
        boolean save = iAdminService.save(admin);
        if (save){
            return R.success("添加成功");
        }
        return R.error("添加失败");
    }

    @PostMapping("/update")
    public R update(Admin admin){
        QueryWrapper<Admin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",admin.getRoleid());
        boolean b = iAdminService.update(admin,queryWrapper);
        if (b){
            return R.success("修改成功");
        }
        return R.error("修改失败");
    }
    @GetMapping("/delete")
    public R delete(Integer roleid){
        QueryWrapper<Admin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",roleid);
        boolean b = iAdminService.remove(queryWrapper);
        if (b){
            return R.success("删除成功");
        }
        return R.error("删除失败");
    }
}
