package com.zoo.controller;



import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zoo.common.R;
import com.zoo.entity.Archive;
import com.zoo.entity.Breedingplan;
import com.zoo.entity.Veterinary;
import com.zoo.service.IArchiveService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author DJ
 * @since 2024-06-07
 */
@RestController
@RequestMapping("/com/zoo/archive")
public class ArchiveController {
    @Autowired
    IArchiveService iArchiveService;

    @GetMapping("info")
    public R info(Integer id,Integer animallId){
        QueryWrapper<Archive> queryWrapper = new QueryWrapper<>();
        if (id!=null){
            queryWrapper.eq("id",id);
            Archive one = iArchiveService.getOne(queryWrapper);
            return R.success(one);
        }
        if (animallId!=null){
            queryWrapper.eq("animallId",animallId);
            List<Archive> list = iArchiveService.list(queryWrapper);
            return R.success(list);
        }

        return R.success(iArchiveService.list());
    }
    @PostMapping("/add")
    public R add(Archive archive){
        boolean save = iArchiveService.save(archive);
        if (save){
            return R.success("添加成功");
        }
        return R.error("添加失败");
    }

    @PostMapping("/update")
    public R update(Archive archive){
        QueryWrapper<Archive> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id",archive.getId());
        boolean update = iArchiveService.update(archive,queryWrapper);
        if (update){
            return R.success("修改成功");
        }
        return R.error("修改失败");
    }
    @GetMapping("/delete")
    public R delete(Integer id){
        QueryWrapper<Archive> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("id",id);
        boolean remove = iArchiveService.remove(queryWrapper);
        if (remove){
            return R.success("删除成功");
        }
        return R.error("删除失败");
    }
}
