package com.zoo.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zoo.common.R;
import com.zoo.dto.AdminDto;
import com.zoo.dto.KeeperDto;
import com.zoo.entity.*;
import com.zoo.service.IAccountService;
import com.zoo.service.IKeeperService;
import com.zoo.service.IVeterinaryService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author DJ
 * @since 2024-05-17
 */
@RestController
@RequestMapping("/zoo/keeper")
public class KeeperController {
    @Autowired
    IKeeperService iKeeperService;
    @Autowired
    IAccountService iAccountService;
    @GetMapping("info")
    public R info(Integer roleid){
        QueryWrapper<Keeper> queryWrapper = new QueryWrapper<>();
        QueryWrapper<Account> queryWrapper1 = new QueryWrapper<>();
        if (roleid!=null){
            queryWrapper.eq("roleid",roleid);
            Keeper keeper = iKeeperService.getOne(queryWrapper);
            queryWrapper1.eq("roleid",roleid);
            queryWrapper1.eq("permissions",1);
            Account one = iAccountService.getOne(queryWrapper1);
            KeeperDto keeperDto = new KeeperDto();
            BeanUtils.copyProperties(keeper,keeperDto);
            keeperDto.setPassword(one.getPassword());
            keeperDto.setUsername(one.getUsername());
            keeperDto.setPermissions(1);
            return R.success(keeperDto);
        }
        List<Keeper> list = iKeeperService.list();
        List<KeeperDto> keeperDtoList = list.stream().map((item)->{
            KeeperDto keeperDto = new KeeperDto();
            BeanUtils.copyProperties(item,keeperDto);
            QueryWrapper<Account> queryWrapper2 = new QueryWrapper<>();
            queryWrapper2.eq("roleid",item.getRoleid());
            queryWrapper2.eq("permissions",1);
            Account one = iAccountService.getOne(queryWrapper2);
            keeperDto.setPassword(one.getPassword());
            keeperDto.setUsername(one.getUsername());
            keeperDto.setPermissions(1);
            return keeperDto;
        }).collect(Collectors.toList());
        return R.success(keeperDtoList);
    }
    @PostMapping("/add")
    public R add(Keeper keeper){
        boolean save = iKeeperService.save(keeper);
        if (save){
            return R.success("添加成功");
        }
        return R.error("添加失败");
    }

    @PostMapping("/update")
    public R update(Keeper keeper){
        QueryWrapper<Keeper> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",keeper.getRoleid());
        boolean b = iKeeperService.update(keeper,queryWrapper);
        if (b){
            return R.success("修改成功");
        }
        return R.error("修改失败");
    }
    @GetMapping("/delete")
    public R delete(Integer roleid){
        QueryWrapper<Keeper> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",roleid);
        boolean b = iKeeperService.remove(queryWrapper);
        if (b){
            return R.success("删除成功");
        }
        return R.error("删除失败");
    }
}
