package com.zoo.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zoo.common.R;
import com.zoo.dto.KeeperDto;
import com.zoo.dto.VeterinaryDto;
import com.zoo.entity.Account;
import com.zoo.entity.Keeper;
import com.zoo.entity.Veterinary;
import com.zoo.service.IAccountService;
import com.zoo.service.IVeterinaryService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author DJ
 * @since 2024-05-17
 */
@RestController
@RequestMapping("/zoo/veterinary")
public class VeterinaryController {
    @Autowired
    IVeterinaryService iVeterinaryService;
    @Autowired
    IAccountService iAccountService;
    @GetMapping("info")
    public R info(Integer roleid){
        QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
        QueryWrapper<Account> queryWrapper1 = new QueryWrapper<>();
        if (roleid!=null){
            queryWrapper.eq("roleid",roleid);
            Veterinary keeper = iVeterinaryService.getOne(queryWrapper);
            queryWrapper1.eq("roleid",roleid);
            queryWrapper1.eq("permissions",2);
            Account one = iAccountService.getOne(queryWrapper1);
            VeterinaryDto veterinaryDto = new VeterinaryDto();
            BeanUtils.copyProperties(keeper,veterinaryDto);
            veterinaryDto.setPassword(one.getPassword());
            veterinaryDto.setUsername(one.getUsername());
            veterinaryDto.setPermissions(2);
            return R.success(veterinaryDto);
        }
        List<Veterinary> list = iVeterinaryService.list();
        List<Veterinary> veterinaryList = list.stream().map((item)->{
            VeterinaryDto veterinaryDto = new VeterinaryDto();
            BeanUtils.copyProperties(item,veterinaryDto);
            QueryWrapper<Account> queryWrapper2 = new QueryWrapper<>();
            queryWrapper2.eq("roleid",item.getRoleid());
            queryWrapper2.eq("permissions",2);
            Account one = iAccountService.getOne(queryWrapper2);
            veterinaryDto.setPassword(one.getPassword());
            veterinaryDto.setUsername(one.getUsername());
            veterinaryDto.setPermissions(2);
            return veterinaryDto;
        }).collect(Collectors.toList());
        return R.success(veterinaryList);
    }
    @PostMapping("/add")
    public R add(Veterinary veterinary){
        boolean save = iVeterinaryService.save(veterinary);
        if (save){
            return R.success("添加成功");
        }
        return R.error("添加失败");
    }

    @PostMapping("/update")
    public R update(Veterinary veterinary){
        QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",veterinary.getRoleid());
        boolean b = iVeterinaryService.update(veterinary,queryWrapper);
        if (b){
            return R.success("修改成功");
        }
        return R.error("修改失败");
    }
    @GetMapping("/delete")
    public R delete(Integer roleid){
        QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",roleid);
        boolean b = iVeterinaryService.remove(queryWrapper);
        if (b){
            return R.success("删除成功");
        }
        return R.error("删除失败");
    }
}
